<?php
declare(strict_types=1);

namespace StarPoolCloud\Providers;

use Illuminate\Support\ServiceProvider;
use StarPoolCloud\Commands\ApolloConfigSync;
use StarPoolCloud\Handles\Apollo\Client;
use StarPoolCloud\Handles\StarPoolCloudHandle;


class StarPoolCloudServiceProvider extends ServiceProvider
{
    /**
     * Bootstrap the application services.
     *
     * @return void
     */
    public function boot()
    {
        $this->publishes([
            realpath(__DIR__ . '/../../config/apollo.php') => config_path('apollo.php')
        ]);
        if ($this->app->runningInConsole()) {
            $this->commands([
                ApolloConfigSync::class
            ]);
        }
    }

    /**
     * Register the service provider.
     *
     * @return void
     */
    public function register()
    {
        $this->app->singleton('StarPoolCloud', function () {
            return new StarPoolCloudHandle();
        });
        $this->app->singleton('StarPoolCloudApollo', function () {
            return new Client(config('apollo'));
        });
    }
}